![Superalgos video capture (16)](https://user-images.githubusercontent.com/9479367/77251218-76d25980-6c4d-11ea-8e47-be7db2e8abdb.gif)

# What is Superalgos?

Superalgos is a platform to automate crypto-tarding. It is a Nodejs + Web App that runs at your hardware and scales from a single Raspberry Pi to a Trading Farm. Superalgos is Free and Open Source.

## Superalgos Features

* A Visual Scripting Designer.
* Integrated Charting System.
* Task Managment across a Trading Farm.
* Community built strategies to learn and start from.

## Superalgos allows you to

* Visually design your own trading strategies.
* Visually design your own indicators.
* Visually design your own plotters (to visualize indicators or data mined).
* Visually design your data-mining operations.
* Download historical market data from crypto exchanges.
* Backtest your strategies against historical data.
* Run live trading sessions.
* Run arbitrary data-mining operations of any size.
* Feed your trading strategies with the data mined.

## Superalgos is user-centric

* No ads, anywhere.
* No sign up / logins.
* No user / usage data collection of any kind.
* Runs 100% on uncompilled code you can read and audit.

# Superalgos for Developers

* You are free to custumize Superalgos for your customers. No royalties, no license fees.
* Everything extra your customers might need you can code it yourself or request it as new features.
* You can use Superalgos as a platform or a component of a larger system.
* No propietary code / libraries. All open source and free.
* Already available a set of community-contributed plugins (workspaces, strategies, indicators, plotters, tutorials, etc.).

## Superalgos saves you time

* No need to code the download of historical data from crypto exchanges.
* No need to code the streming of market data from crypto exchanges.
* No need to hardcode strategies, use the visual designer for a more flexible approach.
* No need to debug what went wrong line by line or diving into log files with tons of data. You can see each variable of the state of the Trading Engine at every candle by hovering the mouse over the charts.
* No need to integrate a charing library, Superalgos has its own integrated Charting System.
* No need to manage task data or execution dependencies by yourself. Superalgos allows you to define Tasks and distribute them acrross a Trading Farm, and it takes cares of the data and execution dependencies, so that each task automatically starts when their dependencies are ready.

# Getting Started

All procedures are the same for Windows, Linux or Mac OS. Note: only tested with Google Chrome.

## Instalation

1. If you don't have it yet, [install Node.js.](https://nodejs.org/en/download/)
2. Open a command prompt or terminal and type:

```
git clone https://github.com/Superalgos/Superalgos
```

## Usage

1. Change to the Superalgos directory / folder and type:
```
node run
```
2. Follow the in-app Welcome Tutorial to learn the basics.

## Uninstall

Just delete the folder Superalgos.

# Support

### Via Telegram

Users online support through our [Superalgos Telegram Community](https://t.me/superalgoscommunity).

Developers online support to through our [Superalgos Telegram Developer's Group](https://t.me/superalgosdevelop).

Support in Spanish through our [Superalgos en Español Telegram Group](https://t.me/superalgos_es).
 
### Via Documentation Site

Self service support available via the [Superalgos Documentation Site](https://docs.superalgos.org/).

### Via Video Tutorials

Self service support via video tutorials at the [Superalgos You Tube Channel](https://www.youtube.com/channel/UCmYSGbB151xFQPNxj7KfKBg).

# Other Resources

### Web Site

For an overview of what Superalgos can do for you, please check the [Superalgos Website](https://superalgos.org/).

### Blog

You can find everything we have written at the [Superalgos Blog](https://medium.com/superalgos).

### Twitter

To stay up-to-date, follow [Superalgos on Twitter](https://twitter.com/superalgos).

### Facebook

To stay up-to-date, follow [Superalgos on Facebook](https://www.facebook.com/superalgos).

# Contributing

Superalgos is a Community Project. Learn [how to become a Contributor](https://docs.superalgos.org/contributing-to-superalgos.html).

## Contributors 

Luis Fernando Molina, Julian Molina, Andreja Cobeljic, Matías Benitez, Ira Miller, Eduardo Remis, Jeff Braun, rico4dev, Barry Low, Nikola Bjelogrlic, Hirajin Koizuko, Francisco J. Santillán, Viktoria B., Javier A., Gustavo J., Romina GS, Pedro P., Thais M., Loui M., Natalia M., Bashar A., Carlos V., Diego M., Sebastian E., Bogdan P., Marko V., Igor S., Niksa K., Rodrigo M. and Nicanor M.

# License

Superalgos is open-source software released under [Apache License 2.0](LICENSE).
